uart.setup(2, 57600, 8, uart.PARITY_NONE, uart.STOPBITS_1, {tx = 17, rx = 16})
uart.start(2)
local parcecom
local parcedtbl = {}

function analizetb(tb)
	--ALARM;2;235030;22;PRT=0;
	if tb[1] == 'ALARM' then
		local tkill = {}
		tkill.sign = tb[1]
		tkill.unit = tb[3]
		tkill.alarm = tb[4]
		tkill.arm =  tb[5] == 'PRT=0' and 'Off' or 'On' 
		ok, json = pcall(sjson.encode, tkill)

		if ok then
			print('Send to Broker:\t', json)
			if dat.broker and m then 
				wth.data = json
				dofile'mqttpub.lua'
			else
				print('No Broker')
			end
		else
			print("failed to encode!")
		end
	end

-- RSTATE;144895;PRT=0;
-- RSTATE;144895;NSL=-94;NSL=-91;NSL=-96;NSL=-92;ONL=1;FUL=1;LLS=-66;FNM=3;DPT=5;PRT=0;
	if tb[1] == 'RSTATE' then
		local tkill = {}
		tkill.sign = tb[1]
		tkill.unit = tb[2]
		if tb[3] == 'PRT=0' or tb[12] == 'PRT=0'  then
			tkill.arm = 'Off'
		elseif tb[3] == 'PRT=1' or tb[12] == 'PRT=1' then
			tkill.arm = 'On'
		end

		if not tkill.arm then return end

		ok, json = pcall(sjson.encode, tkill)

		if ok then
			print('Send to Broker:\t', json)
			if dat.broker and m then 
				wth.data = json
				dofile'mqttpub.lua'
			else
				print('No Broker')
			end
		else
			print("failed to encode!")
		end
	end

-- STATUS;2;235030;1;42;58;258;-94;-31;0;5;0;-1;0;1769;1;-43;0;868.8;PING;
	if tb[1] == 'STATUS' then
		local tkill = {}
		tkill.sign = tb[1]
		tkill.unit = tb[3]
		tkill.bat = tb[10] == '0' and 'On' or 'Off' 
		ok, json = pcall(sjson.encode, tkill)

		if ok then
			print('Send to Broker:\t', json)
			if dat.broker and m then 
				wth.data = json
				dofile'mqttpub.lua'
			else
				print('No Broker')
			end
		else
			print("failed to encode!")
		end
	end

end

function parcecom (packet) 
    print('\npacket', packet)
    parcedtbl = {}
    local str = ''
    local lt = ''
    for i = 1, #packet do
    	lt = string.sub(packet, i,i)
    	if lt ~= ';' then
    		str = str..lt
    	else
			parcedtbl[#parcedtbl + 1] = str
			str = ''
		end
		if i == #packet then
			if str ~='' then
				parcedtbl[#parcedtbl + 1] = str
			end
			str = ''
			--table.foreach(parcedtbl, print)
			analizetb(parcedtbl)
    	end	
    end

end
--]]

local gotuart = ''
local OD = false

function clearUART()
	gotuart = ''
	OD = false
end

uart.on(2,"data",1,
    function(data)
        if data == string.char(0x0D) then 
			OD = true
			return 	
        end
        if OD == true and data == string.char(0x0A) then 
			parcecom(gotuart)
			clearUART()
			return
		else
			OD = false
        end
        gotuart = gotuart..data
end, 0)

function wrUART(str)
	if type(str) == 'string' then
		uart.write(2, str..string.char(0x0D)..string.char(0x0A))
	else
		print('No string to write')
	end
end